Name:          meow
Version:       1.1.0
Release:       1
Summary:       a bunch of install+run scripts for software i use
License:       Unlicense
Requires:      python3 fish rustup ripgrep bat entr git-delta curl shfmt pnpm

%description
fish scripts to run programs, installing them on first run
current programs:
- todoman
- topgrade
- bat-extras
- htmlq
- prettier
- gifski

%prep

%build

%install
mkdir -p %{buildroot}/usr/bin/


cat > %{buildroot}/usr/bin/todo << EOF
#!/usr/bin/env fish
if ! test -e ~/.local/lib/micro_todoman_installation
  echo "installing todoman,,, please wait"
  python3 -m venv ~/.local/lib/micro_todoman_installation
  source ~/.local/lib/micro_todoman_installation/bin/activate.fish
  pip install todoman
  echo (string repeat --count \$COLUMNS -)
end

source ~/.local/lib/micro_todoman_installation/bin/activate.fish
exec todo \$argv
EOF

cat > %{buildroot}/usr/bin/topgrade << EOF
#!/usr/bin/env fish
if ! test -e ~/.cargo/bin/topgrade
  echo "installing topgrade,,, please wait"
  cargo install topgrade
  echo (string repeat --count \$COLUMNS -)
end

exec ~/.cargo/bin/topgrade \$argv
EOF

cat > %{buildroot}/usr/bin/install-bat-extras << EOF
#!/usr/bin/env fish
curl --location --output /tmp/micro_bat_extras.tar.gz https://github.com/eth-p/bat-extras/archive/refs/tags/v2024.08.24.tar.gz
cd /tmp
mkdir micro_bat_extras
tar -xf micro_bat_extras.tar.gz --directory micro_bat_extras
cd micro_bat_extras/*
sudo ./build.sh --install
EOF

cat > %{buildroot}/usr/bin/htmlq << EOF
#!/usr/bin/env fish
if ! test -e ~/.cargo/bin/htmlq
  echo "installing htmlq,,, please wait"
  cargo install htmlq
  echo (string repeat --count \$COLUMNS -)
end

exec ~/.cargo/bin/htmlq \$argv
EOF

cat > %{buildroot}/usr/bin/prettier << EOF
#!/usr/bin/env fish
if test -z "\$PNPM_HOME"
  set_color red
  echo "please set up pnpm first!"
  set_color normal
  exit 1
end

if ! test -e \$PNPM_HOME/prettier
  echo "installing prettier,,, please wait"
  pnpm add --global prettier
  echo (string repeat --count \$COLUMNS -)
end

exec \$PNPM_HOME/prettier \$argv
EOF

cat > %{buildroot}/usr/bin/gifski << EOF
#!/usr/bin/env fish
if ! test -e ~/.cargo/bin/gifski
  echo "installing gifski,,, please wait"
  cargo install gifski
  echo (string repeat --count \$COLUMNS -)
end

exec ~/.cargo/bin/gifski \$argv
EOF

chmod 755 %{buildroot}/usr/bin/todo
chmod 755 %{buildroot}/usr/bin/topgrade
chmod 755 %{buildroot}/usr/bin/install-bat-extras
chmod 755 %{buildroot}/usr/bin/htmlq
chmod 755 %{buildroot}/usr/bin/prettier
chmod 755 %{buildroot}/usr/bin/gifski

%files
/usr/bin/todo
/usr/bin/topgrade
/usr/bin/install-bat-extras
/usr/bin/htmlq
/usr/bin/prettier
/usr/bin/gifski

%changelog
* Tue Sep 03 2024 Niko Red <micro@noreply.localhost> - 1.1.0
- add gifski

* Mon Sep 02 2024 Niko Red <micro@noreply.localhost> - 1.0.3
- hopefully maybe finyally fix all scripts

* Mon Sep 02 2024 Niko Red <micro@noreply.localhost> - 1.0.3
- hotfix 3
- please work aaaaa

* Mon Sep 02 2024 Niko Red <micro@noreply.localhost> - 1.0.2
- hotfix,,, TWO

* Mon Sep 02 2024 Niko Red <micro@noreply.localhost> - 1.0.1
- hotfix

* Mon Sep 02 2024 Niko Red <micro@noreply.localhost> - 1.0.0
- initial release
